Subject: Re: bug#42247: Channel news raise error on `guix pull`

From: Bengt Richter <[email-masked]>
Date: Mon, 13 Jul 2020 14:50:23 +0200

On +2020-07-13 12:27:39 +0200, Ludovic Courtès wrote:
> Hi,
> 
> Pierre Neidhardt <[email-masked]> skribis:
> 
> > Ludovic Courtès <[email-masked]> writes:
> >
> >> This suggests that the ‘news.scm’ file of your channel is being picked
> >> up and evaluated as if it were a module, which it’s not.
> >>
> >> The solution is to rename it to, say, ‘news.txt’, or to move the actual
> >> modules to a sub-directory and specify that in ‘.guix-channel’ (info
> >> "(guix) Channels").
> >
> > Thanks for the hint, this works indeed!
> >
> > 1. Is there anything we can do to catch this error and output a more
> > intelligible error message?
> 
> I don’t think so: Guile is just doing its job and picking up .scm
> files.
>

You are not saying that a file extension is used as hard type data
when "Guile is just doing its job ..." are you?? (unless the producer
of the filename is contracted to guarantee the extension semantics in
guile's environment at the run-time in question ...
but where is such policy documented, if so? (I don't mean looking for
.go files newer than corresponding .scm, etc))

> > 2. I suggest we document this pitfall in the documentation.
> 
> Yup, makes sense; would you like to send a patch?
> 
> Thanks,
> Ludo’.
> 
> 
> 

-- 
Regards,
Bengt Richter